% int x;
% x is the shared global variable
%
%
% static int val=0;
% val is known to A only, i.e. B does not access nor modifies it
%
%A() {
%a1:	assume x=1;
%	x:=0;
%	if * then A();
%a2:	assume x=3;
%a2:	x:=2;
%final:  val++;
%	assert (val<8);
%}
%
%
%B() {
%b1:	x:=1;
%	if * then B();
%b2:	x:=3;
%}
%
%* The pattern which captures an unbounded number of context switches
%for each thread (go(B);x=1;go(A);x=0)* (go(B);x=3;go(A);x=2)*
%


threads(T):-
  MEM0=memDef([int(0,3)-x],[int(0,_H_)-val=0]),
  MEM1=memDef([int(0,3)-x],[]),
  T = [
     thread(0,
        cfGrm(z(t0),
        [
         rule(a0,term(x==1),a1),
         rule(a1,term(x=0),a2),
         rule(a2,a0,a3), %nondeterministic choice
         rule(a2,a3),
         rule(a3,term(x==3),a4),
         rule(a4,term(x=2),a5),
         rule(a5,term(inc(val)),a6),

         rule(a6,term(val>= _H_ ),assertfailed),
         rule(assertfailed,term(assert(false))),
	 rule(a6,term(val< _H_),a7),
	 rule(a7,eps),

	 % by encapsulating a0 in an infinite loop, 
	 % its only way to produce a trace is to actually to execute an assert(false).
	 rule(t0,a0,t1),
	 rule(t1,t1)

        ]
      ),MEM0),

    thread(1,
      cfGrm(z(b0),
        [
         rule(b0,term(x=1),b1),
         rule(b1,b0,b2), %nondeterministic choice
         rule(b1,b2),
         rule(b2,term(x=3),b3),
         rule(b3,eps)
        ]
      ),MEM1)
  ].


pattern(P):-
  P=[
     [go(1),yield(g(1)),go(0),yield(g(0))],
     [go(1),yield(g(3)),go(0),yield(g(2))],
     [go(1),yield(g(3)),go(0)],
     [yield(errmem),go(1)]
    ].
