% int x;
% x is the shared global variable
%
%
% static int val=0;
% val is known to A only, i.e. B does not access nor modifies it
%
%A() {
%a1:	assume x=1;
%	x:=0;
%	if * then A();
%a2:	assume x=3;
%a2:	x:=2;
%final:  val++;
%	assert (val<8);
%}
%
%
%B() {
%b1:	x:=1;
%	if * then B();
%b2:	x:=3;
%}
%
%* The pattern which captures an unbounded number of context switches
%for each thread (go(B);x=1;go(A);x=0)* (go(B);x=3;go(A);x=2)*
%


threads(T):-
  MEM0=memDef([bool-x0=false,bool-x1=false],[bool-val0=false,bool-val1=false,bool-val2=false,bool-val3=false]),
  MEM1=memDef([bool-x0=false,bool-x1=false],[]),
  T = [
      thread(0,
        cfGrm(z(t0),
        [rule(t0,a0,final),
	
         rule(a0,term(and(x0==true,x1==false)),a1),%x==1
         rule(a1,term(and(x0=false,x1=false)),a2), %x=0
         rule(a2,a0,a3), %nondeterministic choice
         rule(a2,a3),
         rule(a3,term(and(x0==true,x1==true)),a4),%x==3
         rule(a4,term(and(x0=false,x1=true)),a5), %x=2
         rule(a5,b1),
%
	 rule(b1,term(val0==false),b2),
	 rule(b2,term(val0=true),bassert),
 	 rule(b1,term(val0==true),b3),
%
	 rule(b3,term(val1==false),b4),
	 rule(b4,term(val1=true),b5),
 	 rule(b5,term(val0=false),bassert),
 	 rule(b3,term(val1==true),b6),
%
 	 rule(b6,term(val2==false),b7),
 	 rule(b7,term(val2=true),b8),
 	 rule(b8,term(val1=false),b9),
 	 rule(b9,term(val0=false),bassert),
 	 rule(b6,term(val2==true),b10),
%
	 rule(b10,term(val3==false),b11),
 	 rule(b11,term(val3=true),b12),
 	 rule(b12,term(val2=false),b13),
 	 rule(b13,term(val1=false),b14),
 	 rule(b14,term(val0=false),bassert),
 	 rule(b10,term(val3==true),bassert),
% The most significant digit fails to be 0
	 rule(bassert,term(val3==false),a6),
	 rule(bassert,term(val3==true),bassertfail),
	 rule(bassertfail,term(assert(false)),bassertfail),
         rule(a6,eps)
%
        ]),MEM0),
    thread(1,
      cfGrm(z(b0),
        [
         rule(b0,term(and(x0=true,x1=false)),b1),%x=1
         rule(b1,b0,b2), %nondeterministic choice
         rule(b1,b2),
         rule(b2,term(and(x0=true,x1=true)),b3),%x=3
         rule(b3,eps)
        ]
      ),MEM1)
  ].


pattern(P):-
  P=[[go(1),yield(g(true,false)),go(0),yield(g(false,false))],
     [go(1),yield(g(true,true)),go(0),yield(g(false,true))],
     [go(1),yield(g(true,true)),go(0)],
     [yield(errmem),go(1)]
    ].
