/** <checks> Sanity checks of the input - currently not used
    
@author Tomas Poch
*/


getUnknownTerminals(_,[],[]).
getUnknownTerminals(REGINIT,[H|T],REST):-
  (rule(REGINIT,H);rule(REGINIT,H,_);rule(REGINIT,_,H);%state modifications can be done in initial state (unlock???)
   rule(_,H);rule(_,H,_);rule(_,_,H) %tests, no need to be grounded 
  ),!,
  getUnknownTerminals(REGINIT,T,REST).
getUnknownTerminals(REGINIT,[H|T],[H|REST]):-getUnknownTerminals(REGINIT,T,REST).

separateCtxSwitches([],[],[]).
separateCtxSwitches([term(H)|T],[H|T1],T2):-(H=go(_);H=yield(_)),!,separateCtxSwitches(T,T1,T2).
separateCtxSwitches([term(H)|T],T1,[H|T2]):-separateCtxSwitches(T,T1,T2).

checkTerms(cfGrm(_,CFRULES,_),regGrm(REGINIT,REGRULES,_)):-
  getTerminalsAndNonterminals(CFRULES,CFTERMS,_),
  %getTerminalsAndNonterminals(REGRULES,REGTERMS,_),
  installGrammarFacts(REGRULES),
  getUnknownTerminals(REGINIT,CFTERMS,TERMNOTINREGGRM),
  separateCtxSwitches(TERMNOTINREGGRM,_,NOCTXSW),
  (NOCTXSW=[]->true;
     (write('terminals not provided by memory grammar:'),writeln(NOCTXSW))
  )
  .
