
/** <load> Load the tool 
    
    @author Tomas Poch
*/
:-consult(library(clpfd)).

%:-use_module(main,
:-consult([  
             main,
             createProduct,
             ctxSwitchRules,
             projection,
             pattern,
             sortClauseBodies,
             execute,
             generateEquations,
             instantiateRules,
             generateRulePredicates,
             solveEquations,
             memgrm,
             preprocessThreads,
	     parsebp, 
%             checks,
             toolstate
]).


:-multifile(threads/1).
:-multifile(pattern/1).

threads(_):-fail.
pattern(_):-fail.

