/** <setImpl_assoc> Set implementation using the assoc library
@author Tomas Poch
*/


findColision([],_).
findColision([NT|NTS],E):-
  encode(NT,F),
  ((F=E)->(write(NT),write(E),nl);true),
  findColision(NTS,E).

inSet(H,iassoc(IASSOC,_,CHECKIN)):-encode(H,E),get_assoc(E,IASSOC,1),(get_assoc(H,CHECKIN,1)->true;(writeln(colision:H),nl,assoc_to_keys(CHECKIN,L),findColision(L,E),trace)).
insertIntoSet(H,iassoc(SETIN,LIN,CHECKIN),iassoc(SETOUT,LOUT,CHECKOUT)):-encode(H,E),
  (get_assoc(E,SETIN,1)->
    (SETOUT=SETIN,LIN=LOUT,CHECKIN=CHECKOUT);
    (put_assoc(E,SETIN,1,SETOUT),LOUT=[H|LIN],put_assoc(H,CHECKIN,1,CHECKOUT))
  ).

emptySet(_,iassoc(H,[],CH)):-empty_assoc(H),empty_assoc(CH).
setToList(iassoc(_,L,_),L).


insertSortedListIntoSet(L,IN,OUT):-insertListIntoSet(L,IN,OUT).
