/** <setImpl_nb_set> Set implementation using the nb_set library
@author Tomas Poch
*/

:-consult(library(nb_set)).

inSet(H,ASSOC):-add_nb_set(H,ASSOC,false).
insertIntoSet(H,SETIN,SETOUT):-add_nb_set(H,SETIN,_),SETOUT=SETIN.
emptySet(_,H):-empty_nb_set(H).
setToList(H,L):-nb_set_to_list(H,L).

insertSortedListIntoSet(L,IN,OUT):-insertListIntoSet(L,IN,OUT).
