/** <setImpl_assoc> Set implementation using the assoc library
@author Tomas Poch
*/


inSet(H,iassoc(IASSOC,_)):-term_to_atom(H,E),get_assoc(E,IASSOC,1).
insertIntoSet(H,iassoc(SETIN,LIN),iassoc(SETOUT,LOUT)):-term_to_atom(H,E),
  (get_assoc(E,SETIN,1)->
    (SETOUT=SETIN,LIN=LOUT);
    (put_assoc(E,SETIN,1,SETOUT),LOUT=[H|LIN])
  ).

emptySet(_,iassoc(H,[])):-empty_assoc(H).
setToList(iassoc(_,L),L).


insertSortedListIntoSet(L,IN,OUT):-insertListIntoSet(L,IN,OUT).
